;Soon, this will be Kairi's Quest!!!

;***include files
	include "tios.h"
	include "graphlib.h"
	include "userlib.h"

;***defines
	xdef	_ti89
	xdef	_main
	xdef	_comment

;***equates
gplane0	equ	graphlib::plane0
gplane1	equ	graphlib::plane1
DOWN	equ	0
UP	equ	1
LEFT	equ	2
RIGHT	equ	3

LEVSIZE	equ	336

;***code starts here!
_main:
	move.l	#0,vid2_addr
        move.l  #3840,-(a7)             ; Allocate 3840 bytes of RAM of screen
        jsr     tios::HeapAlloc         ; buffer
        addq.l  #4,a7
        or.w    d0,d0
        beq     ExitProgram
        move.w  d0,vid1_handle

        tios::DEREF     d0,a0           ; Store pointer to RAM buffer
        move.l  a0,vid1_addr

	move.l  #3840,-(a7)             ; Allocate 3840 bytes of RAM of screen
        jsr     tios::HeapAlloc         ; buffer
        addq.l  #4,a7
        or.w    d0,d0
        beq     ExitFail
        move.w  d0,vid2_handle

        tios::DEREF     d0,a0           ; Store pointer to RAM buffer
        move.l  a0,vid2_addr

MainScreen:
	jsr 	graphlib::gray4			;Set up grayscale and clear screen
	move.w	#1,graphlib::choosescreen
	bsr	ClearScreenG

	move.w 	#3,d0				;the logo is drawn three times, once
	move.w 	#1,d1				;to one grayscale layer and twice
	lea 	Logo(pc),a0			;to the other one to produce a
	move.b 	#$00,d3				;"shadow" effect with monochrome pic
	jsr 	graphlib::put_sprite_mask

	move.w 	#5,d0
	move.w 	#3,d1
	jsr 	graphlib::put_sprite_mask

	move.l 	gplane0,a1
	move.w 	#3,d0
	move.w 	#1,d1
	jsr 	graphlib::put_sprite_mask

	lea 	CharPic1_1(pc),a0		;draws the character image, which is
	move.w 	#5,d0				;a real grayscale image
	move.w 	#24,d1
	jsr 	graphlib::put_sprite_mask
	move.l 	gplane1,a1
	lea 	CharPic1_2(pc),a0
	jsr 	graphlib::put_sprite_mask

	move.w	#80,d0				;draws the grayscale menu box
	move.w	#30,d1
	move.w	#70,d2
	move.w	#60,d3
	move.l	gplane0,a2
	move.l	gplane1,a3
	bsr	DrawWindow

	move.w	#2,d0				;Write menu text
	bsr	Setfont
	move.w	#95,d0
	move.w	#36,d1
	move.w	#4,d2
	lea	StartText(pc),a0
	bsr	Putchar

	move.w	#2,d0
	bsr	Setfont
	move.w	#95,d0
	move.w	#49,d1
	move.w	#4,d2
	lea	LoadText(pc),a0
	bsr	Putchar

	move.w	#2,d0
	bsr	Setfont
	move.w	#95,d0
	move.w	#62,d1
	move.w	#4,d2
	lea	AboutText(pc),a0
	bsr	Putchar

	move.w	#2,d0
	bsr	Setfont
	move.w	#95,d0
	move.w	#75,d1
	move.w	#4,d2
	lea	ExitText(pc),a0
	bsr	Putchar

	move.w	#85,d0				;set the ball coordinates
	move.w	#37,d1

Mainmenu:
	move.l 	gplane0,a1			;draw the menu ball
	lea 	ball1(pc),a0
	lea 	ballmask(pc),a2
	jsr 	graphlib::put_sprite2
	move.l 	gplane1,a1
	lea 	ball2(pc),a0
	jsr 	graphlib::put_sprite2

	bsr	Keywait				;wait for key response
	lea 	blank(pc),a0			;erase the menu ball
	move.l 	gplane0,a1
	move.b 	#$ff,d3
	jsr 	graphlib::put_sprite_mask
	move.l 	gplane1,a1
	jsr 	graphlib::put_sprite_mask

	cmp.w 	#KEY_DOWN,d4			;check keypresses and respond
	beq	MMenuMoveDown
	cmp.w 	#KEY_UP,d4
	beq	MMenuMoveUp
	cmp.w 	#$D,d4
	beq	MMenuEnter
	bra	Mainmenu

MMenuMoveDown:
	cmp.w	#76,d1
	beq	Mainmenu
	add.w	#13,d1
	bra	Mainmenu

MMenuMoveUp:
	cmp.w	#37,d1
	beq	Mainmenu
	sub.w	#13,d1
	bra	Mainmenu


MMenuEnter:
	cmp.w	#37,d1
	beq	StartGame
	cmp.w	#76,d1
	beq	ExitGame
	bra	Mainmenu

;****************************************************

StartGame:					;Start of game


	bsr	Cinema01
	jsr	userlib::idle_loop
	lea	KairiHouse(pc),a0
	move.l	a0,LEVDATA_START		;set level variables
	move.w	#3,Levels_Wide
	move.w	#3,Levels_High

	move.w	#64,Kairi_X			;set character variables
	move.w	#40,Kairi_Y
	move.w	#0,Kairi_Step
	move.w	#DOWN,Kairi_Dir
	move.w	#0,Kairi_LevX
	move.w	#0,Kairi_LevY

	bsr	ClearScreenBuffer
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	DrawScreen


GameLoop:
	bsr	LoadKairi			;Load Kairi's variables

	bsr	DrawGameSprite

	bsr	BufferToScreen			;copy buffer to actual screens

	bsr	EraseGameSprite
	bsr	AnimateSprite
	;
	;additional game code here
	;
	;
						;BEGINNING OF KEYPRESS ROUTINE
        tst.w   tios::kb_globals+$1c		;check for key
        beq     GameLoop			;no key pressed, then loop
	move.w  tios::MaxHandles+$1e,d0		;get keypress in d0
	cmp.w	#$108,d0
	beq	MainScreen
	cmp.w	#KEY_UP,d0
	beq	GameMoveUp
	cmp.w	#KEY_DOWN,d0
	beq	GameMoveDown
	cmp.w	#KEY_LEFT,d0
	beq	GameMoveLeft
	cmp.w	#KEY_RIGHT,d0
	beq	GameMoveRight
	move.w	#0,Kairi_Step
	bra	GameLoop
GameMoveUp:					;Key responses
	move.w	#UP,Kairi_Dir

;***********NEW CODE!!!!************
	cmp.w	#0,Kairi_Y
	bgt	GameMoveUp2
	cmp.w	#0,Kairi_LevY
	beq	SkipMoveUp
	sub.w	#1,Kairi_LevY
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	DrawScreen
	move.w	#80,Kairi_Y
	bra	SkipMoveUp
;***********************************

GameMoveUp2:
	move.w	Kairi_X,d0			;collision detection
	move.w	Kairi_Y,d1
	add.w	#8,d1
	sub.w	#4,d1
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveUp
	move.w	Kairi_X,d0
	move.w	Kairi_Y,d1
	add.w	#8,d1
	sub.w	#4,d1
	add.w	#7,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveUp
	move.w	Kairi_X,d0
	move.w	Kairi_Y,d1
	add.w	#8,d1
	sub.w	#4,d1
	add.w	#15,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveUp
	sub.w	#4,Kairi_Y
SkipMoveUp:
	cmp.w	#0,Kairi_Step
	beq	KairiTakeStep
	bra	GameLoop



GameMoveDown:
	move.w	#DOWN,Kairi_Dir

;***********NEW CODE!!!!************
	cmp.w	#80,Kairi_Y
	blt	GameMoveDown2
	move.w	Levels_High,d0
	sub.w	#1,d0
	move.w	Kairi_LevY,d1
	cmp.w	d0,d1
	beq	SkipMoveUp
	add.w	#1,Kairi_LevY
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	DrawScreen
	move.w	#0,Kairi_Y
	bra	SkipMoveDown
;***********************************

GameMoveDown2:
	move.w	Kairi_X,d0			;collision detection
	move.w	Kairi_Y,d1
	add.w	#8,d1
	add.w	#8,d1
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveDown
	move.w	Kairi_X,d0
	move.w	Kairi_Y,d1
	add.w	#8,d1
	add.w	#8,d1
	add.w	#7,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveDown
	move.w	Kairi_X,d0
	move.w	Kairi_Y,d1
	add.w	#8,d1
	add.w	#8,d1
	add.w	#15,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveDown
	add.w	#4,Kairi_Y


SkipMoveDown:
	cmp.w	#0,Kairi_Step
	beq	KairiTakeStep
	bra	GameLoop



GameMoveLeft:
	move.w	#LEFT,Kairi_Dir
;***********NEW CODE!!!!************
	cmp.w	#0,Kairi_X
	bgt	GameMoveLeft2
	cmp.w	#0,Kairi_LevX
	beq	SkipMoveLeft
	sub.w	#1,Kairi_LevX
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	DrawScreen
	move.w	#96,Kairi_X
	bra	SkipMoveLeft
;***********************************

GameMoveLeft2:
	move.w	Kairi_X,d0		;collision detection
	move.w	Kairi_Y,d1
	add.w	#8,d1
	sub.w	#4,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveLeft
	move.w	Kairi_X,d0
	move.w	Kairi_Y,d1
	add.w	#8,d1
	add.w	#4,d1
	sub.w	#4,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveLeft

	sub.w	#4,Kairi_X
SkipMoveLeft:
	cmp.w	#0,Kairi_Step
	beq	KairiTakeStep
	bra	GameLoop



GameMoveRight:
	move.w	#RIGHT,Kairi_Dir

;***********NEW CODE!!!!************
	cmp.w	#96,Kairi_X
	blt	GameMoveRight2
	move.w	Levels_Wide,d0
	sub.w	#1,d0
	move.w	Kairi_LevX,d1
	cmp.w	d0,d1
	beq	SkipMoveRight
	add.w	#1,Kairi_LevX
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	DrawScreen
	move.w	#0,Kairi_X
	bra	SkipMoveRight
;***********************************

GameMoveRight2:
	move.w	Kairi_X,d0		;collision detection
	move.w	Kairi_Y,d1
	add.w	#8,d1
	add.w	#19,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveRight
	move.w	Kairi_X,d0
	move.w	Kairi_Y,d1
	add.w	#8,d1
	add.w	#4,d1
	add.w	#19,d0
	bsr	GetLevAddress
	movea.l	LEVDATA_ADDR,a0
	bsr	CheckPoint
	lea	TileSettings(pc),a0
	adda.w	d2,a0
	move.b	(a0),d2
	cmp.b	#1,d2
	beq	SkipMoveRight

	add.w	#4,Kairi_X
SkipMoveRight:
	cmp.w	#0,Kairi_Step
	beq	KairiTakeStep
	bra	GameLoop

KairiTakeStep:
	move.w	#1,Kairi_Step
	bra	GameLoop


ExitGame:
	clr.w	graphlib::choosescreen		;next two lines resets to normal screen
	jsr 	graphlib::gray2


        move.w  vid2_handle,-(a7)        ; Free screen buffer handle
        jsr     tios::HeapFree
        addq.l  #2,a7

ExitFail:
        move.w  vid1_handle,-(a7)        ; Free screen buffer handle
        jsr     tios::HeapFree
        addq.l  #2,a7

ExitProgram:
	rts

	include routines.asm
	include cinemas.asm
	include	spec-rtn.asm
	include kairigfx.h
	include tiles.h
	include text.h
	include	levels.h

LEVDATA_START	dc.l	0
LEVDATA_ADDR	dc.l	0
Levels_Wide	dc.w	0		; equal to level dimensions
Levels_High	dc.w	0

CHARX_ADDR	dc.l	0		;Addresses of character vars used for general routines
CHARY_ADDR	dc.l	0
CHARSTEP_ADDR	dc.l	0
CHARDIR_ADDR	dc.l	0
CHARSPRITE_ADDR	dc.l	0

Kairi_X		dc.w	0		;Onscreen X,Y coordinates
Kairi_Y		dc.w	0
Kairi_Step	dc.w	0		;walking (or not) animation counter
Kairi_Dir	dc.w	0		;Direction facing
Kairi_LevX	dc.w	0		;X,Y coordinate in terms of screens
Kairi_LevY	dc.w	0

vid1_handle	dc.w    0
vid1_addr	dc.l    0
vid2_handle	dc.w    0
vid2_addr	dc.l    0

StartText	dc.b "Start",0
LoadText	dc.b "Load",0
AboutText	dc.b "About",0
ExitText	dc.b "Exit",0

_comment	dc.b "Kairi Demo by Jason Nguyen",0

	end